Subject: Re: bug#9273: 23.3; malloc initialization should (sometimes) happen at runtime

From: Stefan Monnier <[email-masked]>
Date: Sat, 13 Aug 2011 11:07:48 -0400

>>> _heapinfo is indeed consistent with the current heap.  But the pointer
>>> that was passed to realloc points into the old heap.  So applying BLOCK
>>> to that pointer yields an absurd result.  I can easily catch such cases
>>> by testing for ptr<  _heapbase, as in my patch to _free_internal_nolock,
>>> but I have to figure out the best way to handle them once I've caught
>>> them.
>> malloc a buffer, then copy the contents of the old one to the new
>> one.  You will have to know the size of the old block, which means you
>> will have to access the old copy of _heapinfo.
> Thanks!  That's much easier than what I was trying to do.

Wouldn't it be easier to try and convince malloc to keep using the old
_heapinfo?

        Stefan